=== modified file 'CHANGES.txt'
--- CHANGES.txt	2013-07-01 14:12:05 +0000
+++ CHANGES.txt	2013-08-01 18:41:36 +0000
@@ -2,6 +2,14 @@
 CHANGES
 =======
 
+2.5.0 (2013-07-03)
+------------------
+
+- Background PDF reports
+- Background XLS export
+- Removed one hundred total constraint on category weights
+
+
 2.4.2 (2013-07-01)
 ------------------
 

=== modified file 'Makefile'
--- Makefile	2013-04-04 17:05:30 +0000
+++ Makefile	2013-08-01 18:41:36 +0000
@@ -4,7 +4,7 @@
 LOCALES=src/schooltool/gradebook/locales
 TRANSLATIONS_ZCML=schooltool/gradebook/translations.zcml
 
-DIST=/home/ftp/pub/schooltool/flourish
+DIST=/home/ftp/pub/schooltool/trunk
 PYTHON=python
 
 INSTANCE_TYPE=schooltool
@@ -44,27 +44,76 @@
 instance: | build
 	bin/make-schooltool-instance instance instance_type=$(INSTANCE_TYPE)
 
+instance/run/supervisord.pid:
+	bin/supervisord
+
 .PHONY: run
-run: build instance
-	bin/start-schooltool-instance instance
+run: build instance instance/run/supervisord.pid
+	@bin/supervisorctl start "services:*"
+	@bin/supervisorctl status schooltool | grep RUNNING && bin/supervisorctl stop schooltool || exit 0
+	@bin/supervisorctl status
+	bin/start-schooltool-instance instance
+
+.PHONY: start
+start: build instance instance/run/supervisord.pid
+	bin/supervisorctl start all
+	@bin/supervisorctl status
+
+.PHONY: start-services
+start-services: build instance instance/run/supervisord.pid
+	@bin/supervisorctl status | grep services[:] | grep -v RUNNING && bin/supervisorctl start "services:*" || exit 0
+	@bin/supervisorctl status | grep services[:]
+
+.PHONY: restart
+restart: build instance instance/run/supervisord.pid
+	@bin/supervisorctl restart "services:celery_report"
+	@bin/supervisorctl start "services:*"
+	bin/supervisorctl restart schooltool
+	@bin/supervisorctl status
+
+.PHONY: rerun
+rerun: build instance instance/run/supervisord.pid
+	@bin/supervisorctl restart "services:celery_report"
+	@bin/supervisorctl start "services:*"
+	@bin/supervisorctl status schooltool | grep RUNNING && bin/supervisorctl stop schooltool || exit 0
+	@bin/supervisorctl status
+	bin/start-schooltool-instance instance
+
+.PHONY: stop
+stop:
+	@test -S instance/run/supervisord.sock && bin/supervisorctl status | grep -v STOPPED && bin/supervisorctl stop all || exit 0
+	@test -S instance/run/supervisord.sock && bin/supervisorctl shutdown || echo Nothing to stop
+	@rm -f instance/run/zeo.sock
+	@rm -f instance/run/supervisord.sock
+	@rm -f instance/run/supervisord.pid
+
+.PHONY: status
+status:
+	@test -f instance/run/supervisord.pid && bin/supervisorctl status || echo All services shut down
 
 .PHONY: tags
 tags: build
 	bin/ctags
 
 .PHONY: clean
-clean:
+clean: stop
 	rm -rf python
 	rm -rf bin develop-eggs parts .installed.cfg
 	rm -rf build
 	rm -f ID TAGS tags
 	rm -rf coverage ftest-coverage
+	rm -rf instance/var/celerybeat-schedule
+	rm -rf instance/var/redis-dump.rdb
+	rm -rf instance/run/zeo.sock
+	rm -rf instance/run/supervisord.sock
+	rm -rf instance/run/supervisord.pid
+	rm -rf instance/var/Data.fs.lock
 	find . -name '*.py[co]' -delete
 	find . -name '*.mo' -delete
 	find . -name 'LC_MESSAGES' -exec rmdir -p --ignore-fail-on-non-empty {} +
 
 .PHONY: realclean
-realclean:
+realclean: stop
 	rm -f buildout.cfg
 	rm -rf eggs
 	rm -rf dist
@@ -162,8 +211,8 @@
 	    echo cp dist/$(PACKAGE)-$${VERSION}.tar.gz $${DIST} ;\
 	    cp dist/$(PACKAGE)-$${VERSION}.tar.gz $${DIST} ;\
 	else \
-	    echo scp dist/$(PACKAGE)-$${VERSION}.tar.gz* schooltool.org:$${DIST} ;\
-	    scp dist/$(PACKAGE)-$${VERSION}.tar.gz* schooltool.org:$${DIST} ;\
+	    echo scp dist/$(PACKAGE)-$${VERSION}.tar.gz* ftp.schooltool.org:$${DIST} ;\
+	    scp dist/$(PACKAGE)-$${VERSION}.tar.gz* ftp.schooltool.org:$${DIST} ;\
 	fi
 
 # Helpers
@@ -173,5 +222,6 @@
 	sudo apt-get install build-essential gettext enscript \
 	    python-dev python-virtualenv \
 	    ttf-ubuntu-font-family ttf-liberation \
-	    libicu-dev libxslt1-dev libfreetype6-dev libjpeg-dev
+	    libicu-dev libxslt1-dev libfreetype6-dev libjpeg-dev \
+	    redis-server
 

=== modified file 'PKG-INFO'
--- PKG-INFO	2013-07-01 14:12:05 +0000
+++ PKG-INFO	2013-08-01 18:41:36 +0000
@@ -1,6 +1,6 @@
 Metadata-Version: 1.1
 Name: schooltool.gradebook
-Version: 2.4.2
+Version: 2.5.0
 Summary: Gradebook plugin for SchoolTool
 Home-page: http://www.schooltool.org
 Author: SchoolTool Developers
@@ -15,6 +15,14 @@
         CHANGES
         =======
         
+        2.5.0 (2013-07-03)
+        ------------------
+        
+        - Background PDF reports
+        - Background XLS export
+        - Removed one hundred total constraint on category weights
+        
+        
         2.4.2 (2013-07-01)
         ------------------
         

=== modified file 'base.cfg'
--- base.cfg	2013-04-04 17:05:30 +0000
+++ base.cfg	2013-08-01 18:41:36 +0000
@@ -1,11 +1,11 @@
 [buildout]
-extends = http://ftp.schooltool.org/schooltool/flourish/versions.cfg
+extends = http://ftp.schooltool.org/schooltool/trunk/versions.cfg
 versions = versions
 newest = false
 find-links =
-    http://ftp.schooltool.org/schooltool/flourish/
-    http://ftp.schooltool.org/schooltool/flourish/dev/
-parts = package test scripts ctags omelette
+    http://ftp.schooltool.org/schooltool/trunk/
+    http://ftp.schooltool.org/schooltool/trunk/dev/
+parts = package test supervisor celery scripts ctags omelette
 
 [package]
 recipe = zc.recipe.egg:eggs
@@ -18,10 +18,51 @@
 unzip = true
 eggs =
     ${package:eggs}
+    ZODB3
+    redis
     schooltool
     schooltool.devtools
+scripts = # ZODB3:
+          runzeo
+          zeopack
+          # schooltool.devtools:
+          i18nextract
+          runfdoctests
+          # schooltool:
+          make-schooltool-instance
+          start-schooltool-instance
+          schooltool-server
+
 interpreter = python
 
+[supervisor]
+recipe = zc.recipe.egg:scripts
+unzip = true
+eggs = supervisor
+scripts = supervisord
+          supervisorctl
+          pidproxy
+          # Useful script if you want to toy with supervisor settings
+          #echo_supervisord_conf
+initialization =
+    import os
+    if os.path.exists('instance'): os.chdir('instance')
+
+[celery]
+recipe = zc.recipe.egg:scripts
+unzip = true
+eggs = ${package:eggs}
+       celery
+       redis
+scripts = # celery:
+          #celerybeat
+          celeryd
+          celeryev
+          celeryctl
+          #camqadm
+          #celeryd-multi
+
+
 [test]
 recipe = schooltool.devtools:testrunner
 eggs = ${package:eggs}

=== modified file 'debian/changelog'
--- debian/changelog	2013-07-01 14:13:24 +0000
+++ debian/changelog	2013-08-01 18:42:41 +0000
@@ -1,3 +1,11 @@
+schooltool.gradebook (2.5.0-0ubuntu1) saucy; urgency=low
+
+  * New upstream release.
+  * debian/control: requires python-schooltool (>= 1:2.5~)
+  * debian/watch: change series to trunk
+
+ -- Gediminas Paulauskas <menesis@pov.lt>  Thu, 01 Aug 2013 21:41:39 +0300
+
 schooltool.gradebook (2.4.2-0ubuntu1) saucy; urgency=low
 
   * New upstream bugfix release.

=== modified file 'debian/control'
--- debian/control	2013-05-30 17:30:52 +0000
+++ debian/control	2013-08-01 18:42:41 +0000
@@ -14,7 +14,7 @@
 Package: python-schooltool.gradebook
 Architecture: all
 Depends: ${pydeb:Depends}, ${python:Depends}, ${misc:Depends},
-         python-schooltool (>= 1:2.4.1)
+         python-schooltool (>= 1:2.5~)
 Provides: ${pydeb:Provides}
 Suggests: ${pydeb:Suggests}
 Description: Gradebook plugin for SchoolTool

=== modified file 'debian/watch'
--- debian/watch	2012-10-30 20:33:24 +0000
+++ debian/watch	2013-08-01 18:42:41 +0000
@@ -1,2 +1,2 @@
 version=3
-http://ftp.schooltool.org/schooltool/flourish/schooltool.gradebook-(\d.*)\.tar\.gz
+http://ftp.schooltool.org/schooltool/trunk/schooltool.gradebook-(\d.*)\.tar\.gz

=== modified file 'setup.py'
--- setup.py	2013-05-30 17:02:42 +0000
+++ setup.py	2013-08-01 18:41:36 +0000
@@ -60,7 +60,7 @@
     package_dir={'': 'src'},
     packages=find_packages('src'),
     namespace_packages=["schooltool"],
-    install_requires=['schooltool>=2.4.1',
+    install_requires=['schooltool>=2.5dev',
                       'lxml',
                       'pytz',
                       'setuptools',

=== modified file 'src/schooltool.gradebook.egg-info/PKG-INFO'
--- src/schooltool.gradebook.egg-info/PKG-INFO	2013-07-01 14:12:05 +0000
+++ src/schooltool.gradebook.egg-info/PKG-INFO	2013-08-01 18:41:36 +0000
@@ -1,6 +1,6 @@
 Metadata-Version: 1.1
 Name: schooltool.gradebook
-Version: 2.4.2
+Version: 2.5.0
 Summary: Gradebook plugin for SchoolTool
 Home-page: http://www.schooltool.org
 Author: SchoolTool Developers
@@ -15,6 +15,14 @@
         CHANGES
         =======
         
+        2.5.0 (2013-07-03)
+        ------------------
+        
+        - Background PDF reports
+        - Background XLS export
+        - Removed one hundred total constraint on category weights
+        
+        
         2.4.2 (2013-07-01)
         ------------------
         

=== modified file 'src/schooltool.gradebook.egg-info/SOURCES.txt'
--- src/schooltool.gradebook.egg-info/SOURCES.txt	2013-05-30 17:02:42 +0000
+++ src/schooltool.gradebook.egg-info/SOURCES.txt	2013-08-01 18:41:36 +0000
@@ -106,6 +106,7 @@
 src/schooltool/gradebook/browser/stests/selenium_extensions.txt
 src/schooltool/gradebook/browser/stests/test_selenium.py
 src/schooltool/gradebook/browser/stests/weighting_categories.txt
+src/schooltool/gradebook/browser/stests/weighting_categories_not_hundred.txt
 src/schooltool/gradebook/browser/templates/actionsViewlet.pt
 src/schooltool/gradebook/browser/templates/activities_overview.pt
 src/schooltool/gradebook/browser/templates/add_edit_activity.pt
@@ -142,7 +143,6 @@
 src/schooltool/gradebook/browser/templates/f_report_card_layout_related.pt
 src/schooltool/gradebook/browser/templates/f_report_sheets.pt
 src/schooltool/gradebook/browser/templates/f_report_sheets_related.pt
-src/schooltool/gradebook/browser/templates/f_request_absences_by_day.pt
 src/schooltool/gradebook/browser/templates/f_request_failing_report.pt
 src/schooltool/gradebook/browser/templates/f_request_student_report.pt
 src/schooltool/gradebook/browser/templates/f_student_grade_history.pt

=== modified file 'src/schooltool.gradebook.egg-info/requires.txt'
--- src/schooltool.gradebook.egg-info/requires.txt	2013-05-30 17:02:42 +0000
+++ src/schooltool.gradebook.egg-info/requires.txt	2013-08-01 18:41:36 +0000
@@ -1,4 +1,4 @@
-schooltool>=2.4.1
+schooltool>=2.5dev
 lxml
 pytz
 setuptools

=== modified file 'src/schooltool/gradebook/browser/activity.py'
--- src/schooltool/gradebook/browser/activity.py	2012-11-29 15:15:43 +0000
+++ src/schooltool/gradebook/browser/activity.py	2013-08-01 18:41:36 +0000
@@ -653,18 +653,11 @@
                     value = None
                 newValues[category] = value
             else:
-                total = 0
                 for category, value in newValues.items():
                     if value is not None:
-                        total += value
-                if total != Decimal(100):
-                    self.message = _('Category weights must add up to 100.')
-                else:
-                    for category, value in newValues.items():
-                        if value is not None:
-                            value = value / 100
-                        self.context.setCategoryWeight(category, value)
-                    self.request.response.redirect(self.nextURL())
+                        value = value / 100
+                    self.context.setCategoryWeight(category, value)
+                self.request.response.redirect(self.nextURL())
 
     def rows(self):
         weights = self.context.getCategoryWeights()
@@ -742,6 +735,14 @@
 class WorksheetsExportView(export.ExcelExportView):
     """A view for exporting worksheets to a XLS file"""
 
+    @property
+    def base_filename(self):
+        section = self.context.__parent__
+        activities = self.context
+        filename = '%s %s' % (section.title, activities.title)
+        filename = filename.replace(' ', '_')
+        return filename
+
     def print_headers(self, ws, worksheet):
         row = 2
         gradebook = interfaces.IGradebook(worksheet)
@@ -789,11 +790,7 @@
     def __call__(self):
         wb = xlwt.Workbook()
         self.export_worksheets(wb)
-        datafile = StringIO()
-        wb.save(datafile)
-        data = datafile.getvalue()
-        self.setUpHeaders(data)
-        return data
+        return wb
 
 
 class LinkedColumnBase(BrowserView):

=== modified file 'src/schooltool/gradebook/browser/configure.zcml'
--- src/schooltool/gradebook/browser/configure.zcml	2013-02-19 00:18:28 +0000
+++ src/schooltool/gradebook/browser/configure.zcml	2013-08-01 18:41:36 +0000
@@ -115,6 +115,7 @@
   <page
       name="export.xls"
       for="..interfaces.IActivities"
+      layer="zope.publisher.interfaces.browser.IBrowserRequest"
       class=".activity.WorksheetsExportView"
       permission="schooltool.view"
       />
@@ -563,19 +564,6 @@
       template="templates/unhide_report_worksheet.pt"
       permission="schooltool.edit"
       />
-  <page
-      name="request_failing_report.html"
-      for="schooltool.term.interfaces.ITerm"
-      class=".request_reports.RequestFailingReportView"
-      template="templates/request_failing_report.pt"
-      permission="schooltool.edit"
-      />
-  <page
-      name="failures_by_term.pdf"
-      for="schooltool.term.interfaces.ITerm"
-      class=".pdf_views.FailingReportPDFView"
-      permission="schooltool.edit"
-      />
 
   <!-- Menu items for ISchoolYear -->
   <menuItem

=== modified file 'src/schooltool/gradebook/browser/flourish.zcml'
--- src/schooltool/gradebook/browser/flourish.zcml	2013-05-30 17:02:42 +0000
+++ src/schooltool/gradebook/browser/flourish.zcml	2013-08-01 18:41:36 +0000
@@ -903,6 +903,20 @@
       permission="schooltool.edit"
       />
 
+  <zope:adapter
+       factory=".request_reports.RequestFailing_score_title"
+       name="label"
+       />
+
+  <zope:adapter
+       factory=".request_reports.RequestFailing_score_discrete_title"
+       name="label"
+       />
+
+  <zope:adapter
+      factory=".request_reports.FailingTextScoreValidator"
+      />
+
   <flourish:page
       name="request_failing_report.html"
       for="schooltool.term.interfaces.ITerm"
@@ -1004,7 +1018,6 @@
         name="request_absences_by_day.html"
         for="schooltool.schoolyear.interfaces.ISchoolYear"
         class=".request_reports.FlourishRequestAbsencesByDayView"
-        template="templates/f_request_absences_by_day.pt"
         permission="schooltool.edit"
         />
     <flourish:page
@@ -1384,4 +1397,29 @@
       permission="schooltool.view"
       />
 
+  <page
+      name="request_failing_report.html"
+      for="schooltool.term.interfaces.ITerm"
+      class=".request_reports.RequestFailingReportView"
+      template="templates/request_failing_report.pt"
+      permission="schooltool.edit"
+      />
+
+  <flourish:pdf
+      name="failures_by_term.pdf"
+      for="schooltool.term.interfaces.ITerm"
+      class=".pdf_views.FailingReportPDFView"
+      permission="schooltool.edit"
+      />
+
+  <zope:utility
+     factory=".request_reports.termactivitychoicesfactory"
+     provides="zope.schema.interfaces.IVocabularyFactory"
+     name="schooltool.gradebook.TermActivityChoices" />
+
+  <zope:utility
+     factory=".request_reports.failingreportscorefactory"
+     provides="zope.schema.interfaces.IVocabularyFactory"
+     name="schooltool.gradebook.FailingReportScores" />
+
 </configure>

=== modified file 'src/schooltool/gradebook/browser/journal.zcml'
--- src/schooltool/gradebook/browser/journal.zcml	2011-07-04 20:16:00 +0000
+++ src/schooltool/gradebook/browser/journal.zcml	2013-08-01 18:41:36 +0000
@@ -1,6 +1,8 @@
 <?xml version="1.0"?>
 <configure
     xmlns="http://namespaces.zope.org/browser"
+    xmlns:zope="http://namespaces.zope.org/zope"
+    xmlns:flourish="http://schooltool.org/flourish"
     i18n_domain="schooltool.gradebook">
 
   <!-- Attendance reports -->
@@ -11,16 +13,20 @@
       template="templates/request_absences_by_day.pt"
       permission="schooltool.edit"
       />
-  <page
+  <zope:adapter factory=".request_reports.AbsenceByDayValidator" />
+
+  <flourish:pdf
       name="absences_by_day.pdf"
       for="schooltool.schoolyear.interfaces.ISchoolYear"
       class=".pdf_views.AbsencesByDayPDFView"
+      content_template="rml/absences_by_day_rml.pt"
       permission="schooltool.edit"
       />
-  <page
+  <flourish:pdf
       name="section_absences.pdf"
       for="schooltool.course.interfaces.ISection"
       class=".pdf_views.SectionAbsencesPDFView"
+      content_template="rml/section_absences_rml.pt"
       permission="schooltool.edit"
       />
 

=== modified file 'src/schooltool/gradebook/browser/pdf_views.py'
--- src/schooltool/gradebook/browser/pdf_views.py	2013-02-19 00:18:28 +0000
+++ src/schooltool/gradebook/browser/pdf_views.py	2013-08-01 18:41:36 +0000
@@ -81,6 +81,44 @@
         return '%s_%s.pdf' % (basename, timestamp)
 
 
+class TermPDFPage(flourish.report.PlainPDFPage):
+
+    current_term = None
+    schoolyear = None
+    term = None
+
+    @property
+    def scope(self):
+        scope = []
+        if self.term is not None:
+            scope.append(self.term.title)
+        if self.schoolyear is not None:
+            scope.append(self.schoolyear.title)
+        return ' | '.join(scope)
+
+    def updateTimespan(self):
+        self.current_term = getUtility(IDateManager).current_term
+        if self.current_term is not None:
+            self.schoolyear = ISchoolYear(self.current_term)
+        if 'term' in self.request:
+            self.term = self.schoolyear.get(self.request['term'])
+
+    def update(self):
+        self.updateTimespan()
+        super(TermPDFPage, self).update()
+
+    def formatDate(self, date, format='mediumDate'):
+        if date is None:
+            return ''
+        formatter = getMultiAdapter((date, self.request), name=format)
+        return formatter()
+
+    def guessPeriodGroup(self, meeting):
+        # XXX: this is a copy-pasted quick fix, evil in it's own way
+        if meeting.period is not None:
+            return meeting.period.title
+        return meeting.dtstart.time().isoformat()[:5]
+
 
 class BaseStudentPDFView(BasePDFView):
     """A base class for all student PDF views"""
@@ -491,10 +529,17 @@
         return self.makeFileName('student_detail_%s' % self.context.__name__)
 
 
-class FailingReportPDFView(BasePDFView):
+class FailingReportPDFView(flourish.report.PlainPDFPage):
     """A view for printing a report of all the students failing an activity"""
 
-    template=ViewPageTemplateFile('rml/failing_report_rml.pt')
+    content_template = flourish.templates.XMLFile('rml/failing_report_rml.pt')
+
+    name = _("Failures by Term")
+
+    @property
+    def message_title(self):
+        return _("term ${term} failures",
+                 mapping={'term': self.term.title})
 
     def __init__(self, context, request):
         super(FailingReportPDFView, self).__init__(context, request)
@@ -510,47 +555,38 @@
         root = IGradebookRoot(ISchoolToolApplication(None))
         return root.deployed[worksheetName][activityName]
 
-    def title(self):
-        return _('Failures by Term Report: ${term}',
-                 mapping={'term': self.term.title})
-
-    @property
-    def filename(self):
-        return self.makeFileName('fail_%s' % self.term.__name__)
-
-    def worksheet_heading(self):
-        return _('Report Sheet:')
-
-    def worksheet_value(self):
-        return self.activity.__parent__.title
-
-    def activity_heading(self):
-        return _('Activity:')
-
-    def activity_value(self):
-        return self.activity.title
-
-    def score_heading(self):
-        return _('Passing Score:')
-
-    def score_value(self):
-        return self.request.get('min', '')
+    def formatDate(self, date, format='mediumDate'):
+        if date is None:
+            return ''
+        formatter = getMultiAdapter((date, self.request), name=format)
+        return formatter()
+
+    @property
+    def scope(self):
+        term = ITerm(self.context)
+        first = self.formatDate(term.first)
+        last = self.formatDate(term.last)
+        return '%s | %s - %s' % (term.title, first, last)
+
+    @property
+    def base_filename(self):
+        return 'failures_%s' % self.term.__name__
+
+    @property
+    def subtitles_left(self):
+        subtitles = [
+            _('Report Sheet: ${worksheet}', mapping={
+                    'worksheet': self.activity.__parent__.title}),
+            _('Activity: ${activity}', mapping={
+                    'activity': self.activity.title}),
+            _('Passing Score: ${score}', mapping={
+                    'score': self.request.get('min', '')}),
+            ]
+        return subtitles
 
     def heading_message(self):
         return _('The following students are at risk of failing the following courses:')
 
-    def name_heading(self):
-        return _('Student')
-
-    def course_heading(self):
-        return _('Course')
-
-    def teacher_heading(self):
-        return _('Teacher(s)')
-
-    def grade_heading(self):
-        return _('Grade')
-
     def getSectionData(self, section):
         data = []
         for worksheet in IActivities(section).values():
@@ -616,21 +652,34 @@
         return results
 
 
-class AbsencesByDayPDFView(BasePDFView):
-    """A view for printing a report with those students absent on a given day"""
-
-    template=ViewPageTemplateFile('rml/absences_by_day_rml.pt')
-
-    def __init__(self, context, request):
-        super(AbsencesByDayPDFView, self).__init__(context, request)
-        self.schoolyear = self.context
-
+class AbsencesByDayPDFView(TermPDFPage):
+
+    name = _('ABSENCES BY DAY')
+
+    @property
+    def message_title(self):
+        day = self.getDay()
+        if day is None:
+            return _('absences by day report')
+        return _('absences for ${day}',
+                 mapping={'day': self.formatDate(day)})
+
+    @property
     def title(self):
-        return _('Absences By Day Report')
+        for_date = self.getDay()
+        if for_date is None:
+            return None
+        formatted_date = self.formatDate(for_date, format="fullDate")
+        return formatted_date
 
     @property
-    def filename(self):
-        return self.makeFileName('abs_day_%s' % self.context.__name__)
+    def base_filename(self):
+        day = self.getDay()
+        if day is None:
+            filename = 'abs_day_' + self.context.__name__
+        else:
+            filename = 'abs_day_%d_%02d_%02d' % (day.year, day.month, day.day)
+        return filename
 
     def getDay(self):
         day = self.request.get('day', None)
@@ -639,9 +688,19 @@
         try:
             year, month, day = [int(part) for part in day.split('-')]
             return datetime.date(datetime(year, month, day))
-        except:
+        except (TypeError, ValueError):
+            pass
+        try:
+            return datetime.date(day)
+        except (TypeError, ValueError):
             return None
 
+    def formatDate(self, date, format='mediumDate'):
+        if date is None:
+            return ''
+        formatter = getMultiAdapter((date, self.request), name=format)
+        return formatter()
+
     def compareDates(self, first, second):
         return (first.year == second.year and first.month == second.month and
                 first.day == second.day)
@@ -683,23 +742,21 @@
                 periods[period] = 0
         return sorted(periods.keys())
 
-    def date_heading(self):
-        day = self.getDay()
-        if day is None:
-            return ''
-        else:
-            return day.strftime('%A %B %0d, %Y')
-
-    def periods_heading(self):
-        return _('Period Number')
-
-    def name_heading(self):
-        return _('Student')
-
     def widths(self):
         data = self.getData()
         periods = self.getPeriods(data)
-        return '8cm' + ',1cm' * len(periods)
+        n_cols = len(periods)
+        if not n_cols:
+            return None
+        col_width = max(int(40./n_cols), 8)
+        widths_string = ' '.join(
+            ['%d%%' % max((100-col_width*n_cols), 10)] +
+            ['%d%%' % col_width] * (n_cols)
+            )
+        return widths_string
+
+    def header_widths(self):
+        return '60% 40%'
 
     def periods(self):
         data = self.getData()
@@ -723,47 +780,44 @@
         return rows
 
 
-class SectionAbsencesPDFView(BasePDFView):
+class SectionAbsencesPDFView(TermPDFPage):
     """A view for printing a report with absences for a given section"""
 
-    template=ViewPageTemplateFile('rml/section_absences_rml.pt')
-
-    def __init__(self, context, request):
-        super(SectionAbsencesPDFView, self).__init__(context, request)
-        self.section = self.context
-
+    name = _('SECTION ABSENCES')
+
+    @property
+    def message_title(self):
+        return _('${section} absence report',
+                 mapping={'section': self.section.title})
+
+    @property
     def title(self):
-        return _('Absences by Section Report')
-
-    @property
-    def filename(self):
-        courses = [c.__name__ for c in self.context.courses]
-        return self.makeFileName('abs_section_%s' % '_'.join(courses))
-
-    def course_heading(self):
-        return _('Course')
-
-    def course(self):
-        return ', '.join([course.title for course in self.section.courses])
-
-    def teacher_heading(self):
-        return _('Teacher')
-
-    def teacher(self):
-        return ', '.join(['%s %s' % (teacher.first_name, teacher.last_name)
-                          for teacher in self.section.instructors])
-
-    def student_heading(self):
-        return _('Student')
-
-    def absences_heading(self):
-        return _('Absences')
-
-    def tardies_heading(self):
-        return _('Tardies')
-
-    def total_heading(self):
-        return _('Total')
+        return self.section.title
+
+    @property
+    def section(self):
+        return self.context
+
+    @property
+    def subtitles_left(self):
+        instructors = ['%s %s' % (teacher.first_name, teacher.last_name)
+                       for teacher in self.section.instructors]
+        subtitles = [
+            _('Teacher(s): ${instructors}',
+              mapping={'instructors': ', '.join(instructors)})
+            ]
+        return subtitles
+
+    @property
+    def base_filename(self):
+        courses = [c.__name__ for c in self.section.courses]
+        filename = 'abs_section_%s' % '_'.join(courses)
+        return filename
+
+    def updateTimespan(self):
+        self.term = ITerm(self.section)
+        self.schoolyear = ISchoolYear(self.term)
+        self.current_term = getUtility(IDateManager).current_term
 
     def getStudentData(self, jd, student):
         student_data = {}
@@ -910,6 +964,11 @@
         return formatter()
 
     @property
+    def message_title(self):
+        return _('${section} gradebook',
+                 mapping={'section': self.section.title})
+
+    @property
     def scope(self):
         term = ITerm(self.section)
         schoolyear = ISchoolYear(term)

=== modified file 'src/schooltool/gradebook/browser/request_reports.py'
--- src/schooltool/gradebook/browser/request_reports.py	2012-04-18 17:48:20 +0000
+++ src/schooltool/gradebook/browser/request_reports.py	2013-08-01 18:41:36 +0000
@@ -23,21 +23,229 @@
 from datetime import datetime
 from urllib import unquote_plus
 
+import zope.schema
+import zope.schema.vocabulary
+import zope.schema.interfaces
+import z3c.form
 from zope.browserpage.viewpagetemplatefile import ViewPageTemplateFile
 from zope.component import getUtility
+from zope.i18n import translate
+from zope.interface import implements, Interface
 from zope.publisher.browser import BrowserView
 from zope.traversing.browser.absoluteurl import absoluteURL
 
 from schooltool.app.interfaces import ISchoolToolApplication
 from schooltool.schoolyear.interfaces import ISchoolYear
-from schooltool.term.interfaces import IDateManager
+from schooltool.term.interfaces import IDateManager, ITerm
+from schooltool.export.export import RequestXLSReportDialog
+from schooltool.report.browser.report import RequestRemoteReportDialog
 
 from schooltool.gradebook import GradebookMessage as _
 from schooltool.gradebook.interfaces import IGradebookRoot
+from schooltool.gradebook.gradebook import GradebookReportTask
+from schooltool.gradebook.gradebook import TraversableXLSReportTask
 from schooltool.requirement.interfaces import ICommentScoreSystem
 from schooltool.requirement.interfaces import IDiscreteValuesScoreSystem
 from schooltool.skin.flourish.form import Dialog
-from schooltool.report.browser.report import RequestReportDownloadDialog
+
+
+class TermActivityChoices(zope.schema.vocabulary.SimpleVocabulary):
+    implements(zope.schema.interfaces.IContextSourceBinder)
+
+    def __init__(self, context):
+        self.context = context
+        terms = self.createTerms(ITerm(self.context.get('term')))
+        zope.schema.vocabulary.SimpleVocabulary.__init__(self, terms)
+
+    def createTerms(self, term):
+        result = []
+        result.append(self.createTerm(
+                None,
+                z3c.form.widget.SequenceWidget.noValueToken,
+                _("Select a source"),
+                ))
+        root = IGradebookRoot(ISchoolToolApplication(None))
+        schoolyear = ISchoolYear(term)
+        deployedKey = '%s_%s' % (schoolyear.__name__, term.__name__)
+        for key in root.deployed:
+            if key.startswith(deployedKey):
+                deployedWorksheet = root.deployed[key]
+                for activity in deployedWorksheet.values():
+                    if ICommentScoreSystem.providedBy(activity.scoresystem):
+                        continue
+                    title = '%s - %s - %s' % (term.title,
+                        deployedWorksheet.title, activity.title)
+                    token = '%s-%s-%s' % (term.__name__,
+                        deployedWorksheet.__name__, activity.__name__)
+                    token=unicode(token).encode('punycode')
+                    result.append(self.createTerm(
+                        (deployedWorksheet, activity,),
+                        token,
+                        title,
+                        ))
+        return result
+
+
+def termactivitychoicesfactory():
+    return TermActivityChoices
+
+
+class FailingReportScores(zope.schema.vocabulary.SimpleVocabulary):
+    implements(zope.schema.interfaces.IContextSourceBinder)
+
+    def __init__(self, context):
+        self.context = context
+        terms = self.createTerms()
+        zope.schema.vocabulary.SimpleVocabulary.__init__(self, terms)
+
+    def createTerms(self):
+        result = []
+        scoresystem = self.context.get('scoresystem')
+        if not scoresystem:
+            return result
+        result.append(self.createTerm(
+                None,
+                z3c.form.widget.SequenceWidget.noValueToken,
+                _("Select a score"),
+                ))
+        for score in scoresystem.scores:
+            title = score[0]
+            result.append(self.createTerm(
+                    score[0],
+                    'scr-%s' % unicode(title).encode('punycode'),
+                    title,
+                    ))
+        return result
+
+
+def failingreportscorefactory():
+    return FailingReportScores
+
+
+class IRequestFailingReport(Interface):
+
+    source = zope.schema.Choice(
+        title=(u"Report Activity"),
+        source="schooltool.gradebook.TermActivityChoices",
+        required=True)
+
+
+class ITextMinmaxScore(Interface):
+
+    score = zope.schema.TextLine(
+        title=_(u'Score'),
+        required=True)
+
+
+class IDiscreteValuesMinmaxScore(Interface):
+
+    score = zope.schema.Choice(
+        title=(u"Score"),
+        source="schooltool.gradebook.FailingReportScores",
+        required=True)
+
+
+class FailingTextScoreValidator(z3c.form.validator.SimpleFieldValidator):
+
+    def validate(self, value):
+        scoresystem = self.context.get('scoresystem')
+        if not scoresystem:
+            raise zope.schema.interfaces.RequiredMissing()
+        if (value is not self.field.missing_value and
+            not scoresystem.isValidScore(value)):
+            raise z3c.form.converter.FormatterValidationError(
+                _("${value} is not valid in ${scoresystem}.",
+                    mapping={
+                        'value': value,
+                        'scoresystem': scoresystem.description or scoresystem.title,
+                    }),
+                value)
+        return z3c.form.validator.SimpleFieldValidator.validate(self, value)
+
+
+class FlourishRequestFailingReportView(RequestRemoteReportDialog):
+
+    fields = z3c.form.field.Fields(IRequestFailingReport)
+
+    report_builder = 'failures_by_term.pdf'
+
+    def resetForm(self):
+        RequestRemoteReportDialog.resetForm(self)
+        self.form_params['term'] = self.context
+        self.updateWidgets()
+        if 'score' not in self.widgets:
+            self.addScoreField()
+        self.form_params['scoresystem'] = self.scoresystem
+
+    def updateWidgets(self):
+        super(FlourishRequestFailingReportView, self).updateWidgets()
+        if (self.widgets and 'score' in self.widgets and
+            unicode(self.source_token) != self.request.get('source_token')):
+            widget = self.widgets['score']
+            widget.value = widget.__class__(widget.request).value
+            widget.ignoreRequest = True
+            widget.update()
+        self.widgets['source'].onchange = u"ST.dialogs.submit(this)"
+
+    @property
+    def source_token(self):
+        return self.widgets['source'].value
+
+    @property
+    def scoresystem(self):
+        widget = self.widgets['source']
+        if not widget.value:
+            return None
+        res = widget.terms.getValue(widget.value[0])
+        if not res:
+            return None
+        worksheet, activity = res
+        return activity.scoresystem
+
+    def addScoreField(self):
+        scoresystem = self.scoresystem
+        if not scoresystem:
+            return
+        if (IDiscreteValuesScoreSystem.providedBy(scoresystem) and
+            scoresystem.scores):
+            self.fields += z3c.form.field.Fields(IDiscreteValuesMinmaxScore['score'])
+        else:
+            self.fields += z3c.form.field.Fields(ITextMinmaxScore['score'])
+
+    @property
+    def score_title(self):
+        scoresystem = self.scoresystem
+        if scoresystem and IDiscreteValuesScoreSystem.providedBy(scoresystem):
+            if scoresystem._isMaxPassingScore:
+                return _('Maximum Passing Score')
+        return _('Minimum Passing Score')
+
+    def updateTaskParams(self, task):
+        term = self.context
+        deployedWorksheet, activity = self.form_params['source']
+        task.request_params['activity'] = '%s|%s|%s' % (
+            term.__name__, deployedWorksheet.__name__, activity.__name__)
+        task.request_params['min'] = self.form_params.get('score')
+
+
+RequestFailing_score_title = z3c.form.widget.ComputedWidgetAttribute(
+    lambda adapter: translate(adapter.view.score_title, context=adapter.request),
+    view=FlourishRequestFailingReportView,
+    field=ITextMinmaxScore['score']
+    )
+
+
+z3c.form.validator.WidgetValidatorDiscriminators(
+    FailingTextScoreValidator,
+    view=FlourishRequestFailingReportView,
+    field=ITextMinmaxScore['score'])
+
+
+RequestFailing_score_discrete_title = z3c.form.widget.ComputedWidgetAttribute(
+    lambda adapter: translate(adapter.view.score_title, context=adapter.request),
+    view=FlourishRequestFailingReportView,
+    field=IDiscreteValuesMinmaxScore['score']
+    )
 
 
 class RequestFailingReportView(BrowserView):
@@ -258,45 +466,80 @@
         RequestStudentReportView.update(self)
 
 
-class FlourishRequestFailingReportView(RequestReportDownloadDialogBase,
-                                       RequestFailingReportView):
-
-    def update(self):
-        RequestReportDownloadDialogBase.update(self)
-        RequestFailingReportView.update(self)
-
-
-class FlourishRequestAbsencesByDayView(RequestReportDownloadDialogBase,
-                                       RequestAbsencesByDayView):
-
-    def update(self):
-        RequestReportDownloadDialogBase.update(self)
-        RequestAbsencesByDayView.update(self)
-
-
-class FlourishRequestSectionAbsencesView(RequestReportDownloadDialog):
-
-    def nextURL(self):
-        return absoluteURL(self.context, self.request) + '/section_absences.pdf'
-
-
-class FlourishRequestPrintableWorksheetView(RequestReportDownloadDialog):
-
-    def nextURL(self):
-        return absoluteURL(self.context, self.request) + '/gradebook.pdf'
-
-
-class FlourishRequestGradebookExportView(RequestReportDownloadDialog):
-
-    def nextURL(self):
+class IRequestAbsencesByDayForm(Interface):
+
+    date = zope.schema.Date(
+        title=_(u'Date'),
+        required=True)
+
+
+class DayMustBeInSchoolYear(zope.schema.interfaces.ValidationError):
+    __doc__ = _('You must specify a valid date within the school year.')
+
+
+class AbsenceByDayValidator(z3c.form.validator.SimpleFieldValidator):
+
+    def validate(self, value):
+        date = value
+        if (date is None or
+            date < self.view.schoolyear.first or
+            date > self.view.schoolyear.last):
+            raise DayMustBeInSchoolYear(value)
+
+
+class FlourishRequestAbsencesByDayView(RequestRemoteReportDialog):
+
+    fields = z3c.form.field.Fields(IRequestAbsencesByDayForm)
+
+    report_builder = 'absences_by_day.pdf'
+
+    title = _('Request Absences By Day Report')
+
+    @property
+    def schoolyear(self):
+        return self.context
+
+    def update(self):
+        self.message = ''
+        RequestRemoteReportDialog.update(self)
+
+    def updateTaskParams(self, task):
+        date = self.form_params.get('date')
+        if date is not None:
+            day = '%d-%02d-%02d' % (date.year, date.month, date.day)
+            task.request_params['day'] = day
+
+
+z3c.form.validator.WidgetValidatorDiscriminators(
+    AbsenceByDayValidator,
+    view=FlourishRequestAbsencesByDayView,
+    field=IRequestAbsencesByDayForm['date'])
+
+
+class FlourishRequestSectionAbsencesView(RequestRemoteReportDialog):
+
+    report_builder = 'section_absences.pdf'
+
+
+class FlourishRequestPrintableWorksheetView(RequestRemoteReportDialog):
+
+    report_builder = 'gradebook.pdf'
+    task_factory = GradebookReportTask
+
+
+class FlourishRequestGradebookExportView(RequestXLSReportDialog):
+
+    report_builder = 'export.xls'
+    task_factory = TraversableXLSReportTask
+
+    @property
+    def target(self):
         worksheet = self.context.__parent__
         activities = worksheet.__parent__
-        return absoluteURL(activities, self.request) + '/export.xls'
-
-
-class FlourishRequestReportSheetsExportView(RequestReportDownloadDialog):
-
-    def nextURL(self):
-        url = absoluteURL(self.context, self.request)
-        return url + '/export_report_sheets.xls'
+        return (activities.__parent__, activities.__name__)
+
+
+class FlourishRequestReportSheetsExportView(RequestXLSReportDialog):
+
+    report_builder = 'export_report_sheets.xls'
 

=== modified file 'src/schooltool/gradebook/browser/rml/absences_by_day_rml.pt'
--- src/schooltool/gradebook/browser/rml/absences_by_day_rml.pt	2011-04-18 19:08:14 +0000
+++ src/schooltool/gradebook/browser/rml/absences_by_day_rml.pt	2013-08-01 18:41:36 +0000
@@ -1,101 +1,54 @@
-<?xml version="1.0" standalone="no" ?>
-<!DOCTYPE document SYSTEM "rml_1_0.dtd" [
-  <!ENTITY pound   "&#xA3;">
-  <!ENTITY nbsp    "&#160;">
-]>
-
-<document
-  xmlns:tal="http://xml.zope.org/namespaces/tal"
-  xmlns:metal="http://xml.zope.org/namespaces/metal"
-  xmlns:i18n="http://xml.zope.org/namespaces/i18n"
-  metal:use-macro="context/@@rml_macros/report"
-  i18n:domain="schooltool.gradebook">
-
-<metal:block fill-slot="page_templates">
-  <tal:block content="structure view/use_template/default" />
-</metal:block>
-
-<stylesheet>
-  <metal:block fill-slot="extra_initialize">
-  </metal:block>
-  <metal:block fill-slot="stylesheet">
-
-    <paraStyle
-      name="normal"
-      fontName="Arial_Normal"
-      fontSize="10"
-      leading="12"/>
-
-    <paraStyle
-      name="bold"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="left"
-      leading="12"/>
-
-    <paraStyle
-      name="heading"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="right"
-      leading="12"/>
-
-    <paraStyle
-      name="section_heading"
-      fontName="Arial_Bold"
-      fontSize="12"
-      alignment="center"
-      leading="12"/>
-
-    <blockTableStyle id="headings_table">
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-
-    <blockTableStyle id="grid">
-    	<lineStyle kind="OUTLINE"
-          colorName="black" thickness="0.25"
-          start="0,0" stop="-1,-1" />
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-  </metal:block>
-</stylesheet>
-
-<story metal:fill-slot="story">
-  <para style="section_heading" tal:content="view/date_heading" />
-  <spacer length="1cm" />
-
-  <blockTable style="headings_table" colWidths="8cm,4cm">
-    <tr>
-      <td />
-      <td><para style="bold" tal:content="view/periods_heading" /></td>
-    </tr>
-  </blockTable>
-  <spacer length=".2cm" />
-
-  <blockTable style="grid"
-              tal:attributes="colWidths view/widths">
-    <tr>
-      <td><para style="bold" tal:content="view/name_heading" /></td>
-      <td tal:repeat="period view/periods">
-        <para style="bold" tal:content="period" />
-      </td>
-    </tr>
-  </blockTable>
-
-  <blockTable style="headings_table"
-              tal:condition="python: len(view.periods()) > 0"
-              tal:attributes="colWidths view/widths">
-    <tr tal:repeat="student view/students">
-      <td><para style="bold" tal:content="student/name" /></td>
-      <td tal:repeat="period student/periods">
-        <para style="normal" tal:content="period" />
-      </td>
-    </tr>
-  </blockTable>
-
-  <condPageBreak height="88cm"/>
-
-</story>
-
-</document>
-
+<tal:block
+    xmlns:tal="http://xml.zope.org/namespaces/tal"
+    xmlns:metal="http://xml.zope.org/namespaces/metal"
+    xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+    i18n:domain="schooltool.gradebook">
+
+  <pto>
+    <pto_header>
+      <hr width="100%" thickness="1" cap="square" color="separator"
+          spaceAfter="4" spaceBefore="8" align="center" />
+      <para style="section-title" i18n:translate="">Absences (continued)</para>
+      <blockTable style="multi-table.header"
+                  tal:attributes="colWidths view/header_widths">
+        <tr>
+          <td />
+          <td i18n:translate="">Period Number</td>
+        </tr>
+      </blockTable>
+    </pto_header>
+    <pto_trailer>
+      <para style="pagesplit-continued">Continued on next page &gt;</para>
+    </pto_trailer>
+
+    <hr width="100%" thickness="1" cap="square" color="separator"
+        spaceAfter="4" spaceBefore="8" align="center" />
+    <para style="section-title" i18n:translate="">Absences</para>
+
+    <blockTable style="multi-table.header"
+                tal:attributes="colWidths view/header_widths">
+      <tr>
+        <td />
+        <td i18n:translate="">Period Number</td>
+     </tr>
+    </blockTable>
+
+    <blockTable style="multi-table.subtable"
+                tal:define="periods view/periods"
+                tal:condition="periods"
+                tal:attributes="colWidths view/widths">
+      <tr>
+        <td i18n:translate="">Student</td>
+        <tal:block repeat="period periods">
+          <td tal:content="period"></td>
+        </tal:block>
+      </tr>
+      <tr tal:repeat="student view/students">
+        <td tal:content="student/name"></td>
+        <tal:block repeat="period student/periods">
+          <td tal:content="period"></td>
+        </tal:block>
+      </tr>
+    </blockTable>
+  </pto>
+</tal:block>

=== modified file 'src/schooltool/gradebook/browser/rml/failing_report_rml.pt'
--- src/schooltool/gradebook/browser/rml/failing_report_rml.pt	2011-04-18 19:08:14 +0000
+++ src/schooltool/gradebook/browser/rml/failing_report_rml.pt	2013-08-01 18:41:36 +0000
@@ -1,117 +1,45 @@
-<?xml version="1.0" standalone="no" ?>
-<!DOCTYPE document SYSTEM "rml_1_0.dtd" [
-  <!ENTITY pound   "&#xA3;">
-  <!ENTITY nbsp    "&#160;">
-]>
-
-<document
-  xmlns:tal="http://xml.zope.org/namespaces/tal"
-  xmlns:metal="http://xml.zope.org/namespaces/metal"
-  xmlns:i18n="http://xml.zope.org/namespaces/i18n"
-  metal:use-macro="context/@@rml_macros/report"
-  i18n:domain="schooltool.gradebook">
-
-<metal:block fill-slot="page_templates">
-  <tal:block content="structure view/use_template/default" />
-</metal:block>
-
-<stylesheet>
-  <metal:block fill-slot="extra_initialize">
-  </metal:block>
-  <metal:block fill-slot="stylesheet">
-
-    <paraStyle
-      name="normal"
-      fontName="Arial_Normal"
-      fontSize="10"
-      leading="12"/>
-
-    <paraStyle
-      name="bold"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="left"
-      leading="12"/>
-
-    <paraStyle
-      name="heading"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="right"
-      leading="12"/>
-
-    <paraStyle
-      name="section_heading"
-      fontName="Arial_Bold"
-      fontSize="12"
-      alignment="center"
-      leading="12"/>
-
-    <blockTableStyle id="headings_table">
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-
-    <blockTableStyle id="grid">
-    	<lineStyle kind="OUTLINE"
-          colorName="black" thickness="0.25"
-          start="0,0" stop="-1,-1" />
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-  </metal:block>
-</stylesheet>
-
-<story metal:fill-slot="story">
-  <blockTable style="headings_table" colWidths="6cm,6cm"
-              alignment="center">
-    <tr>
-      <td><para style="heading" tal:content="view/worksheet_heading" /></td>
-      <td><para style="bold" tal:content="view/worksheet_value" /></td>
-    </tr>
-    <tr>
-      <td><para style="heading" tal:content="view/activity_heading" /></td>
-      <td><para style="bold" tal:content="view/activity_value" /></td>
-    </tr>
-    <tr>
-      <td><para style="heading" tal:content="view/score_heading" /></td>
-      <td><para style="bold" tal:content="view/score_value" /></td>
-    </tr>
-  </blockTable>
-
-  <spacer length=".5cm" />
-  <para style="bold" tal:content="view/heading_message" />
-
-  <spacer length=".5cm" />
-  <blockTable style="grid" colWidths="3cm,6cm,6cm,4cm"
-              alignment="left">
-    <tr>
-      <td><para style="bold" tal:content="view/name_heading" /></td>
-      <td><para style="bold" tal:content="view/course_heading" /></td>
-      <td><para style="bold" tal:content="view/teacher_heading" /></td>
-      <td><para style="bold" tal:content="view/grade_heading" /></td>
-    </tr>
-  </blockTable>
-  <spacer length=".5cm" />
-
-  <tal:block repeat="student view/students">
-
-    <para style="bold" tal:content="student/name" />
-
-    <blockTable style="headings_table" colWidths="3cm,6cm,6cm,4cm"
-                alignment="left"
-                tal:condition="python: len(student['rows']) > 0">
-      <tr tal:repeat="row student/rows">
-        <td />
-        <td><para style="normal" tal:content="row/course" /></td>
-        <td><para style="normal" tal:content="row/teacher" /></td>
-        <td><para style="normal" tal:content="row/grade" /></td>
+<tal:block
+    xmlns:tal="http://xml.zope.org/namespaces/tal"
+    xmlns:metal="http://xml.zope.org/namespaces/metal"
+    xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+    i18n:domain="schooltool">
+
+    <pto>
+      <pto_header>
+        <hr width="100%" thickness="1" cap="square" color="separator"
+            spaceAfter="4" spaceBefore="8" align="center" />
+        <para style="section-title" i18n:translate="">Students at risk of failing courses (continued)</para>
+      </pto_header>
+      <pto_trailer>
+        <para style="pagesplit-continued" i18n:translate="">Continued on next page &gt;</para>
+      </pto_trailer>
+
+      <hr width="100%" thickness="1" cap="square" color="separator"
+          spaceAfter="4" spaceBefore="8" align="center" />
+      <para style="section-title" i18n:translate="">Students at risk of failing courses</para>
+
+    <blockTable style="table" colWidths="25% 25% 25% 25%" repeatRows="1" alignment="left">
+      <tr>
+        <td i18n:translate="">Student</td>
+        <td i18n:translate="">Course</td>
+        <td i18n:translate="">Teacher(s)</td>
+        <td i18n:translate="">Grade</td>
       </tr>
+      <tal:block repeat="student view/students">
+        <tr>
+          <td><para tal:content="student/name" /></td>
+          <td></td>
+          <td></td>
+          <td></td>
+        </tr>
+        <tr tal:repeat="row student/rows">
+          <td />
+          <td><para tal:content="row/course" /></td>
+          <td><para tal:content="row/teacher" /></td>
+          <td><para tal:content="row/grade" /></td>
+        </tr>
+      </tal:block>
     </blockTable>
-    <spacer length=".5cm" />
-  </tal:block>
-
-  <condPageBreak height="88cm"/>
-
-</story>
-
-</document>
-
+
+    </pto>
+</tal:block>

=== modified file 'src/schooltool/gradebook/browser/rml/section_absences_rml.pt'
--- src/schooltool/gradebook/browser/rml/section_absences_rml.pt	2011-04-18 19:08:14 +0000
+++ src/schooltool/gradebook/browser/rml/section_absences_rml.pt	2013-08-01 18:41:36 +0000
@@ -1,99 +1,55 @@
-<?xml version="1.0" standalone="no" ?>
-<!DOCTYPE document SYSTEM "rml_1_0.dtd" [
-  <!ENTITY pound   "&#xA3;">
-  <!ENTITY nbsp    "&#160;">
-]>
-
-<document
-  xmlns:tal="http://xml.zope.org/namespaces/tal"
-  xmlns:metal="http://xml.zope.org/namespaces/metal"
-  xmlns:i18n="http://xml.zope.org/namespaces/i18n"
-  metal:use-macro="context/@@rml_macros/report"
-  i18n:domain="schooltool.gradebook">
-
-<metal:block fill-slot="page_templates">
-  <tal:block content="structure view/use_template/default" />
-</metal:block>
-
-<stylesheet>
-  <metal:block fill-slot="extra_initialize">
-  </metal:block>
-  <metal:block fill-slot="stylesheet">
-
-    <paraStyle
-      name="normal"
-      fontName="Arial_Normal"
-      fontSize="10"
-      leading="12"/>
-
-    <paraStyle
-      name="bold"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="left"
-      leading="12"/>
-
-    <paraStyle
-      name="heading"
-      fontName="Arial_Bold"
-      fontSize="10"
-      alignment="right"
-      leading="12"/>
-
-    <paraStyle
-      name="section_heading"
-      fontName="Arial_Bold"
-      fontSize="12"
-      alignment="center"
-      leading="12"/>
-
-    <blockTableStyle id="headings_table">
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-
-    <blockTableStyle id="grid">
-    	<lineStyle kind="OUTLINE"
-          colorName="black" thickness="0.25"
-          start="0,0" stop="-1,-1" />
-        <blockValign value="top" start="0,0" stop="0,-1"/>
-    </blockTableStyle>
-  </metal:block>
-</stylesheet>
-
-<story metal:fill-slot="story">
-  <blockTable style="headings_table" colWidths="4cm,4cm,4cm,4cm">
-    <tr>
-      <td><para style="heading" tal:content="view/course_heading" /></td>
-      <td><para style="normal" tal:content="view/course" /></td>
-      <td><para style="heading" tal:content="view/teacher_heading" /></td>
-      <td><para style="normal" tal:content="view/teacher" /></td>
-    </tr>
-  </blockTable>
-  <spacer length=".5cm" />
-
-  <blockTable style="grid" colWidths="7.5cm,2.5cm,2.5cm,2.5cm">
-    <tr>
-      <td><para style="bold" tal:content="view/student_heading" /></td>
-      <td><para style="bold" tal:content="view/absences_heading" /></td>
-      <td><para style="bold" tal:content="view/tardies_heading" /></td>
-      <td><para style="bold" tal:content="view/total_heading" /></td>
-    </tr>
-  </blockTable>
-  <spacer length=".2cm" />
-
-  <blockTable style="headings_table" colWidths="7.5cm,2.5cm,2.5cm,2.5cm"
-              tal:condition="python: len(view.students()) > 0">
-    <tr tal:repeat="student view/students">
-      <td><para style="normal" tal:content="student/name" /></td>
-      <td><para style="normal" tal:content="student/absences" /></td>
-      <td><para style="normal" tal:content="student/tardies" /></td>
-      <td><para style="normal" tal:content="student/total" /></td>
-    </tr>
-  </blockTable>
-
-  <condPageBreak height="88cm"/>
-
-</story>
-
-</document>
+<tal:block
+    xmlns:tal="http://xml.zope.org/namespaces/tal"
+    xmlns:metal="http://xml.zope.org/namespaces/metal"
+    xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+    i18n:domain="schooltool.gradebook">
+
+  <pto>
+    <pto_header>
+      <hr width="100%" thickness="1" cap="square" color="separator"
+          spaceAfter="4" spaceBefore="8" align="center" />
+      <para style="section-title" i18n:translate="">Absences (continued)</para>
+      <blockTable style="multi-table.header"
+                  colWidths="55% 15% 15% 15%">
+        <tr>
+          <td i18n:translate="">Student</td>
+          <td i18n:translate="">Absences</td>
+          <td i18n:translate="">Tardies</td>
+          <td i18n:translate="">Total</td>
+        </tr>
+      </blockTable>
+    </pto_header>
+    <pto_trailer>
+      <para style="pagesplit-continued">Continued on next page &gt;</para>
+    </pto_trailer>
+
+    <hr width="100%" thickness="1" cap="square" color="separator"
+        spaceAfter="4" spaceBefore="8" align="center" />
+    <para style="section-title" i18n:translate="">Absences</para>
+    <blockTable style="multi-table.header"
+                colWidths="55% 15% 15% 15%">
+      <tr>
+        <td i18n:translate="">Student</td>
+        <td i18n:translate="">Absences</td>
+        <td i18n:translate="">Tardies</td>
+        <td i18n:translate="">Total</td>
+      </tr>
+    </blockTable>
+
+    HELLO!
+    <tal:block define="students view/students"
+               condition="students">
+      <blockTable style="multi-table.content-only"
+                  colWidths="55% 15% 15% 15%">
+        <tr tal:repeat="student students">
+          <td tal:content="student/name"></td>
+          <td tal:content="student/absences"></td>
+          <td tal:content="student/tardies"></td>
+          <td tal:content="student/total"></td>
+        </tr>
+      </blockTable>
+    </tal:block>
+  </pto>
+
+</tal:block>
 

=== modified file 'src/schooltool/gradebook/browser/stests/weighting_categories.txt'
--- src/schooltool/gradebook/browser/stests/weighting_categories.txt	2012-10-30 20:29:01 +0000
+++ src/schooltool/gradebook/browser/stests/weighting_categories.txt	2013-08-01 18:41:36 +0000
@@ -159,23 +159,9 @@
     icon
     101 is not a valid weight.
 
-We'll fill in valid values for Assignment, Homework and Exam, but they
-will not add up to 100.  We should get an error message to that
-effect.
-
-    >>> stephan.query.id('assignment').clear()
-    >>> stephan.query.id('assignment').ui.set_value('99')
-    >>> stephan.query.id('exam').ui.set_value('99')
-    >>> stephan.query.id('homework').ui.set_value('99')
-    >>> stephan.query.name('UPDATE_SUBMIT').click()
-    >>> print stephan.query.css('.ui-state-error').text
-    icon
-    Category weights must add up to 100.
-
-If we get the weights to add up to 100, hitting 'Submit' will succeed
-and return us to the gradebook.  There we will note the effect of the
-weighting in the Average column.
-
+We'll fill in valid values for Assignment, Homework and Exam. Hitting
+'Submit' will succeed and return us to the gradebook.  There we will
+note the effect of the weighting in the Average column.
 
     >>> stephan.query.id('assignment').clear()
     >>> stephan.query.id('assignment').ui.set_value('20')

=== added file 'src/schooltool/gradebook/browser/stests/weighting_categories_not_hundred.txt'
--- src/schooltool/gradebook/browser/stests/weighting_categories_not_hundred.txt	1970-01-01 00:00:00 +0000
+++ src/schooltool/gradebook/browser/stests/weighting_categories_not_hundred.txt	2013-08-01 18:41:36 +0000
@@ -0,0 +1,211 @@
+Category Weighting when weights don't add up to 100
+---------------------------------------------------
+
+We'll test that the Category Weights view doesn't need the weights to
+add up to 100 anymore.
+
+Log in as manager:
+
+    >>> manager = browsers.manager
+    >>> manager.ui.login('manager', 'schooltool')
+
+Now, set up a school year (2005-2006) with a single term (Year):
+
+    >>> manager.ui.schoolyear.add('2005-2006', '2005-09-01', '2006-07-15')
+    >>> manager.ui.term.add('2005-2006', 'Year', '2005-09-01', '2006-07-15')
+
+Set up a course:
+
+    >>> manager.ui.course.add('2005-2006', 'Physics I')
+
+Set up persons:
+
+    >>> manager.ui.person.add('Paul', 'Carduner', 'paul', 'pwd')
+    >>> manager.ui.person.add('Tom', 'Hoffman', 'tom', 'pwd')
+    >>> manager.ui.person.add('Claudia', 'Richter', 'claudia', 'pwd')
+    >>> manager.ui.person.add('Stephan', 'Richter', 'stephan', 'pwd')
+
+Set up a section with instructor and students:
+
+    >>> manager.ui.section.add('2005-2006', 'Year', 'Physics I')
+    >>> manager.ui.section.instructors.add('2005-2006', 'Year', 'Physics I (1)',
+    ...                                    ['stephan'])
+    >>> manager.ui.section.students.add('2005-2006', 'Year', 'Physics I (1)',
+    ...                                 ['tom', 'claudia', 'paul'])
+
+Log in as teacher and go to his gradebook:
+
+    >>> stephan = browsers.stephan
+    >>> stephan.ui.login('stephan', 'pwd')
+    >>> stephan.query.link('Gradebook').click()
+
+Add some activities to the default worksheet:
+
+    >>> stephan.query.link('Activity').click()
+    >>> stephan.query.id('form-widgets-title').ui.set_value('HW 1')
+    >>> stephan.query.id('form-widgets-category').ui.set_value('Homework')
+    >>> stephan.query.id('form-widgets-max').clear()
+    >>> stephan.query.id('form-widgets-max').ui.set_value('50')
+    >>> stephan.query.id('form-buttons-add').click()
+
+    >>> stephan.query.link('Activity').click()
+    >>> stephan.query.id('form-widgets-title').ui.set_value('Quiz 1')
+    >>> stephan.query.id('form-widgets-category').ui.set_value('Exam')
+    >>> stephan.query.id('form-buttons-add').click()
+
+    >>> stephan.query.link('Activity').click()
+    >>> stephan.query.id('form-widgets-title').ui.set_value('HW 2')
+    >>> stephan.query.id('form-widgets-category').ui.set_value('Homework')
+    >>> stephan.query.id('form-widgets-max').clear()
+    >>> stephan.query.id('form-widgets-max').ui.set_value('50')
+    >>> stephan.query.id('form-buttons-add').click()
+
+    >>> stephan.query.link('Activity').click()
+    >>> stephan.query.id('form-widgets-title').ui.set_value('Quiz 2')
+    >>> stephan.query.id('form-widgets-category').ui.set_value('Exam')
+    >>> stephan.query.id('form-buttons-add').click()
+
+Add grades for the first three activities for Paul:
+
+    >>> stephan.ui.gradebook.worksheet.score('Carduner, Paul', 'HW1', '40')
+    >>> stephan.ui.gradebook.worksheet.score('Carduner, Paul', 'Quiz1', '90')
+    >>> stephan.ui.gradebook.worksheet.score('Carduner, Paul', 'HW2', '45')
+
+Add grades for the first three activities for Tom:
+
+    >>> stephan.ui.gradebook.worksheet.score('Hoffman, Tom', 'HW1', '45')
+    >>> stephan.ui.gradebook.worksheet.score('Hoffman, Tom', 'Quiz1', '80')
+    >>> stephan.ui.gradebook.worksheet.score('Hoffman, Tom', 'HW2', '50')
+
+Add grades for the first three activities for Claudia:
+
+    >>> stephan.ui.gradebook.worksheet.score('Richter, Claudia', 'HW1', '50')
+    >>> stephan.ui.gradebook.worksheet.score('Richter, Claudia', 'Quiz1', '95')
+    >>> stephan.ui.gradebook.worksheet.score('Richter, Claudia', 'HW2', '50')
+
+    >>> stephan.query.name('UPDATE_SUBMIT').click()
+
+By default the Average column is calculated normally:
+
+    >>> stephan.ui.gradebook.worksheet.pprint()
+    +----------+
+    | *Sheet1* |
+    +----------+
+    +------------------+-----+-------+-----+-------+-------+-------+
+    | Name             | HW1 | Quiz1 | HW2 | Quiz2 | Total | Ave.  |
+    |                  | 50  | 100   | 50  | 100   |       |       |
+    +------------------+-----+-------+-----+-------+-------+-------+
+    | Carduner, Paul   | 40  | 90    | 45  |       | 175.0 | 87.5% |
+    | Hoffman, Tom     | 45  | 80    | 50  |       | 175.0 | 87.5% |
+    | Richter, Claudia | 50  | 95    | 50  |       | 195.0 | 97.5% |
+    +------------------+-----+-------+-----+-------+-------+-------+
+
+Let's create some category weights for the current worksheet. We'll
+fill in valid values for Assignment, Homework and Exam, even though
+they don't add up to 100, hitting 'Submit' will succeed and return us
+to the gradebook.  There we will note the effect of the weighting in
+the Average column.
+
+    >>> stephan.query.link('Category Weights').click()
+    >>> stephan.query.id('assignment').clear()
+    >>> stephan.query.id('assignment').ui.set_value('10')
+    >>> stephan.query.id('exam').clear()
+    >>> stephan.query.id('exam').ui.set_value('25')
+    >>> stephan.query.id('homework').clear()
+    >>> stephan.query.id('homework').ui.set_value('15')
+    >>> stephan.query.name('UPDATE_SUBMIT').click()
+    >>> stephan.ui.gradebook.worksheet.pprint()
+    +----------+
+    | *Sheet1* |
+    +----------+
+    +------------------+-----+-------+-----+-------+-------+-------+
+    | Name             | HW1 | Quiz1 | HW2 | Quiz2 | Total | Ave.  |
+    |                  | 50  | 100   | 50  | 100   |       |       |
+    +------------------+-----+-------+-----+-------+-------+-------+
+    | Carduner, Paul   | 40  | 90    | 45  |       | 175.0 | 88.1% |
+    | Hoffman, Tom     | 45  | 80    | 50  |       | 175.0 | 85.6% |
+    | Richter, Claudia | 50  | 95    | 50  |       | 195.0 | 96.9% |
+    +------------------+-----+-------+-----+-------+-------+-------+
+
+Let's add a new Assignment activity:
+
+    >>> stephan.query.link('Activity').click()
+    >>> stephan.query.id('form-widgets-title').ui.set_value('Experiment')
+    >>> stephan.query.id('form-widgets-category').ui.set_value('Assignment')
+    >>> stephan.query.id('form-widgets-max').clear()
+    >>> stephan.query.id('form-widgets-max').ui.set_value('10')
+    >>> stephan.query.id('form-buttons-add').click()
+
+Let's grade the new assignment for Paul and Tom:
+
+    >>> stephan.ui.gradebook.worksheet.score('Carduner, Paul', 'Exper', '9')
+    >>> stephan.ui.gradebook.worksheet.score('Hoffman, Tom', 'Exper', '7')
+    >>> stephan.query.name('UPDATE_SUBMIT').click()
+
+Note how the Average changed for Paul and Tom, but not for Claudia:
+
+    >>> stephan.ui.gradebook.worksheet.pprint()
+    +----------+
+    | *Sheet1* |
+    +----------+
+    +------------------+-----+-------+-----+-------+-------+-------+-------+
+    | Name             | HW1 | Quiz1 | HW2 | Quiz2 | Exper | Total | Ave.  |
+    |                  | 50  | 100   | 50  | 100   | 10    |       |       |
+    +------------------+-----+-------+-----+-------+-------+-------+-------+
+    | Carduner, Paul   | 40  | 90    | 45  |       | 9     | 184.0 | 88.5% |
+    | Hoffman, Tom     | 45  | 80    | 50  |       | 7     | 182.0 | 82.5% |
+    | Richter, Claudia | 50  | 95    | 50  |       |       | 195.0 | 96.9% |
+    +------------------+-----+-------+-----+-------+-------+-------+-------+
+
+Now, let's only give Homeworks some weight:
+
+    >>> stephan.query.link('Category Weights').click()
+    >>> stephan.query.id('assignment').clear()
+    >>> stephan.query.id('exam').clear()
+    >>> stephan.query.id('homework').clear()
+    >>> stephan.query.id('homework').ui.set_value('1')
+    >>> stephan.query.name('UPDATE_SUBMIT').click()
+
+The Averages have changed:
+
+    >>> stephan.ui.gradebook.worksheet.pprint()
+    +----------+
+    | *Sheet1* |
+    +----------+
+    +------------------+-----+-------+-----+-------+-------+-------+--------+
+    | Name             | HW1 | Quiz1 | HW2 | Quiz2 | Exper | Total | Ave.   |
+    |                  | 50  | 100   | 50  | 100   | 10    |       |        |
+    +------------------+-----+-------+-----+-------+-------+-------+--------+
+    | Carduner, Paul   | 40  | 90    | 45  |       | 9     | 184.0 | 85.0%  |
+    | Hoffman, Tom     | 45  | 80    | 50  |       | 7     | 182.0 | 95.0%  |
+    | Richter, Claudia | 50  | 95    | 50  |       |       | 195.0 | 100.0% |
+    +------------------+-----+-------+-----+-------+-------+-------+--------+
+
+Let's test that explicit zeros are saved:
+
+    >>> stephan.query.link('Category Weights').click()
+    >>> stephan.query.id('assignment').clear()
+    >>> stephan.query.id('assignment').ui.set_value('0.0')
+    >>> stephan.query.id('essay').clear()
+    >>> stephan.query.id('essay').ui.set_value('0.0')
+    >>> stephan.query.id('exam').clear()
+    >>> stephan.query.id('lab').clear()
+    >>> stephan.query.id('lab').ui.set_value('0.0')
+    >>> stephan.query.id('project').clear()
+    >>> stephan.query.id('project').ui.set_value('0.0')
+    >>> stephan.query.name('UPDATE_SUBMIT').click()
+
+Since all these weights are zero, they shouldn't affect the averages:
+
+    >>> stephan.ui.gradebook.worksheet.pprint()
+    +----------+
+    | *Sheet1* |
+    +----------+
+    +------------------+-----+-------+-----+-------+-------+-------+--------+
+    | Name             | HW1 | Quiz1 | HW2 | Quiz2 | Exper | Total | Ave.   |
+    |                  | 50  | 100   | 50  | 100   | 10    |       |        |
+    +------------------+-----+-------+-----+-------+-------+-------+--------+
+    | Carduner, Paul   | 40  | 90    | 45  |       | 9     | 184.0 | 85.0%  |
+    | Hoffman, Tom     | 45  | 80    | 50  |       | 7     | 182.0 | 95.0%  |
+    | Richter, Claudia | 50  | 95    | 50  |       |       | 195.0 | 100.0% |
+    +------------------+-----+-------+-----+-------+-------+-------+--------+

=== removed file 'src/schooltool/gradebook/browser/templates/f_request_absences_by_day.pt'
--- src/schooltool/gradebook/browser/templates/f_request_absences_by_day.pt	2011-11-29 20:56:56 +0000
+++ src/schooltool/gradebook/browser/templates/f_request_absences_by_day.pt	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-<div i18n:domain="schooltool.gradebook">
-  <div class="status" tal:condition="view/message">
-    <div class="summary ui-state-error ui-corner-all">
-      <span class="ui-icon ui-icon-alert">icon</span>
-      <tal:block content="view/message">
-        [error message]
-      </tal:block>
-    </div>
-  </div>
-  <form method="post"
-        tal:attributes="action string:${context/@@absolute_url}/request_absences_by_day.html">
-    <input type="hidden" name="form-submitted" value="" />
-    <input type="hidden" name="description" tal:attributes="value view/description"
-           tal:condition="view/description|nothing" />
-    <input type="hidden" name="file_type" tal:attributes="value view/file_type"
-           tal:condition="view/file_type|nothing" />
-    <table>
-      <tbody>
-        <tr>
-          <td i18n:translate="">
-            Description
-          </td>
-          <td tal:content="view/description" />
-        </tr>
-        <tr>
-          <td i18n:translate="">
-            File Type
-          </td>
-          <td tal:content="view/file_type" />
-        </tr>
-        <tr>
-          <td i18n:translate="">Date (yyyy-mm-dd)</td>
-          <td>
-            <input type="text" id="day" name="day" class="text-widget date-field"
-                   tal:attributes="value view/currentDay" />
-          </td>
-        </tr>
-      </tbody>
-    </table>
-    <div class="buttons">
-      <input type="submit" class="button-ok" name="DOWNLOAD"
-             onclick="return ST.dialogs.submit(this, this);"
-             value="Download" i18n:attributes="value" />
-      <input type="submit" class="button-cancel" name="CANCEL"
-             onclick="return ST.dialogs.close(this);"
-             value="Cancel" i18n:attributes="value" />
-    </div>
-  </form>
-</div>

=== modified file 'src/schooltool/gradebook/browser/templates/f_request_failing_report.pt'
--- src/schooltool/gradebook/browser/templates/f_request_failing_report.pt	2011-11-29 20:56:56 +0000
+++ src/schooltool/gradebook/browser/templates/f_request_failing_report.pt	2013-08-01 18:41:36 +0000
@@ -1,81 +1,30 @@
-<div i18n:domain="schooltool.gradebook">
-  <div class="status" tal:condition="view/message">
-    <div class="summary ui-state-error ui-corner-all">
-      <span class="ui-icon ui-icon-alert">icon</span>
-      <tal:block content="view/message">
-        [error message]
-      </tal:block>
-    </div>
-  </div>
-  <form method="post"
-        tal:attributes="action string:${context/@@absolute_url}/request_failing_report.html">
-    <input type="hidden" name="form-submitted" value="" />
-    <table>
-      <tbody>
-        <tr>
-          <td colspan="2" i18n:translate="">
-            This report is a list of students achieving below a
-            minimum score on a selected activity from a report sheet.
-          </td>
-        </tr>
-        <tr>
-          <td colspan="2" i18n:translate="">
-            For example, say the term is "Fall 2011," and you have
-            deployed a report sheet entitled "Semester Grades," which
-            includes an activity "First Quarter," using a grading
-            scale where a "3" or higher is passing.  To create a
-            report of students failing the first quarter grade, you
-            would select the report activity "Fall 2011 - Semester
-            Grades - First Quarter" and choose "3" as the minimum
-            passing grade.  And click "Submit."
-          </td>
-        </tr>
-        <tr>
-          <td colspan="2">
-            <h3 i18n:translate="">Request Report</h3>
-          </td>
-        </tr>
-        <tr>
-          <td i18n:translate="">Report Activity</td>
-          <td>
-            <select id="source" name="source">
-              <tal:block repeat="choice view/choices">
-                <option tal:condition="python: choice['value'] == view.current_source()"
-                        selected="selected"
-                        tal:attributes="value choice/value"
-                        tal:content="choice/name" />
-                <option tal:condition="python: choice['value'] != view.current_source()"
-                        tal:attributes="value choice/value"
-                        tal:content="choice/name" />
-              </tal:block>
-            </select>
-          </td>
-        </tr>
-        <tr>
-          <td tal:content="view/minmax" />
-          <td>
-            <select id="score" name="score"
-                    tal:condition="python: len(view.scores()) > 0">
-              <tal:block repeat="score view/scores">
-                <option tal:content="score/name"
-                        tal:attributes="value score/value;
-                                        selected score/selected" />
-              </tal:block>
-            </select>
-            <input type="text" id="score" name="score"
-                   tal:attributes="value request/score|nothing"
-                   tal:condition="python: len(view.scores()) == 0" />
-          </td>
-        </tr>
-      </tbody>
-    </table>
-    <div class="buttons">
-      <input type="submit" class="button-ok" name="DOWNLOAD"
-             onclick="return ST.dialogs.submit(this, this);"
-             value="Download" i18n:attributes="value" />
-      <input type="submit" class="button-cancel" name="CANCEL"
-             onclick="return ST.dialogs.close(this);"
-             value="Cancel" i18n:attributes="value" />
-    </div>
-  </form>
+<div i18n:domain="schooltool">
+  <table class="report-dialog-message">
+    <tbody>
+      <tr>
+        <td i18n:translate="">
+          Description
+        </td>
+        <td tal:content="view/description" />
+      </tr>
+      <tr>
+        <td i18n:translate="">
+          File Type
+        </td>
+        <td tal:content="view/file_type" />
+      </tr>
+    </tbody>
+  </table>
+  <metal:block use-macro="macro:form">
+    <div metal:fill-slot="extra-widgets">
+      <input name="file_type" type="hidden"
+             tal:attributes="value view/request/file_type|nothing"
+             tal:condition="view/request/file_type|nothing" />
+      <input name="description" type="hidden"
+             tal:attributes="value view/request/description|nothing"
+             tal:condition="view/request/description|nothing" />
+      <input name="source_token" type="hidden"
+             tal:attributes="value view/source_token|nothing" />
+    </div>
+  </metal:block>
 </div>

=== modified file 'src/schooltool/gradebook/browser/templates/f_weight_categories_related.pt'
--- src/schooltool/gradebook/browser/templates/f_weight_categories_related.pt	2011-11-29 20:56:56 +0000
+++ src/schooltool/gradebook/browser/templates/f_weight_categories_related.pt	2013-08-01 18:41:36 +0000
@@ -8,8 +8,7 @@
       calculating average scores within a worksheet.
     </p>
     <p i18n:translate="">
-      Enter numeric values for each relevant category. The total of
-      all values must be exactly 100.
+      Enter numeric values for each relevant category.
     </p>
     <p i18n:translate="">
       For example, to weight exams as 60% of the grade, homework as

=== modified file 'src/schooltool/gradebook/browser/xls_views.py'
--- src/schooltool/gradebook/browser/xls_views.py	2012-04-18 17:48:20 +0000
+++ src/schooltool/gradebook/browser/xls_views.py	2013-08-01 18:41:36 +0000
@@ -28,16 +28,21 @@
 from schooltool.export import export
 from schooltool.schoolyear.interfaces import ISchoolYear
 from schooltool.skin import flourish
+from schooltool.task.progress import normalized_progress
 
 from schooltool.gradebook.interfaces import IGradebookRoot, IActivities
 from schooltool.gradebook.interfaces import ISectionJournalData
 from schooltool.requirement.interfaces import IEvaluations
 
+from schooltool.gradebook import GradebookMessage as _
+
 
 class FlourishReportSheetsExportTermView(export.ExcelExportView,
                                          flourish.page.Page):
     """A view for exporting report sheets to an XLS file"""
 
+    message_title = _('report sheets export')
+
     def print_headers(self, ws):
         headers = ['Section ID', 'Student ID', 'Absent', 'Tardy']
         for activity in self.activities:
@@ -62,7 +67,6 @@
                 self.write(ws, row, 2, unicode(absences))
             if tardies:
                 self.write(ws, row, 3, unicode(tardies))
-
         evaluations = IEvaluations(student)
         for index, activity in enumerate(self.activities):
             worksheet = activities[activity.__parent__.__name__]
@@ -71,9 +75,11 @@
             if score:
                 self.write(ws, row, index + 4, unicode(score.value))
 
-    def print_grades(self, ws):
+    def print_grades(self, ws, term_idx, total_terms):
         row = 1
-        for section in ISectionContainer(self.term).values():
+
+        sections = ISectionContainer(self.term).values()
+        for ns, section in enumerate(sections):
             jd = ISectionJournalData(section, None)
             activities = IActivities(section)
             students = sorted(section.members, key=lambda s: s.username)
@@ -82,19 +88,38 @@
                 self.write(ws, row, 0, section.__name__)
                 row += 1
             else:
-                for student in students:
+                for nstud, student in enumerate(students):
                     self.print_student(ws, row, section, jd, activities,
                                        student)
                     row += 1
+                    self.progress('worksheets', normalized_progress(
+                            term_idx, total_terms,
+                            ns, len(sections),
+                            nstud, len(students),
+                            ))
+            self.progress('worksheets', normalized_progress(
+                    term_idx, total_terms,
+                    ns, len(sections),
+                    ))
 
-    def export_term(self, wb):
+    def export_term(self, wb, idx, total_terms):
+        self.progress('worksheets', normalized_progress(
+                idx, total_terms,
+                ))
         ws = wb.add_sheet(self.term.__name__)
         self.print_headers(ws)
-        self.print_grades(ws)
+        self.print_grades(ws, idx, total_terms)
 
-    def getFileName(self):
-        return 'report_sheets_%s_%s.xls' % (self.schoolyear.__name__,
-                                            self.term.__name__)
+    @property
+    def base_filename(self):
+        terms = self.getTerms()
+        if not terms:
+            return 'report_sheets'
+        term = terms[-1]
+        schoolyear = ISchoolYear(term)
+        base_filename =  'report_sheets_%s_%s.xls' % (schoolyear.__name__,
+                                                      term.__name__)
+        return base_filename
 
     def getTerms(self):
         return [self.context]
@@ -108,21 +133,32 @@
                 activities.extend(sheet.values())
         return activities
 
+    def export_terms(self, workbook, terms):
+        terms = list(terms)
+        for nt, self.term in enumerate(terms):
+            self.schoolyear = ISchoolYear(self.term)
+            self.activities = self.getActivities()
+            self.export_term(workbook, nt, len(terms))
+
+        self.finish('worksheets')
+
+    def addImporters(self, progress):
+        progress.add(
+            'worksheets',
+            title=_('Term Worksheets'), progress=0.0)
+
     def __call__(self):
+        self.makeProgress()
+        self.task_progress.title = _("Exporting worksheets")
+        self.addImporters(self.task_progress)
+
         wb = xlwt.Workbook()
 
-        for self.term in self.getTerms():
-            self.schoolyear = ISchoolYear(self.term)
-            self.activities = self.getActivities()
-            self.export_term(wb)
+        self.export_terms(wb, self.getTerms())
 
-        datafile = StringIO()
-        wb.save(datafile)
-        data = datafile.getvalue()
-        self.setUpHeaders(data)
-        disposition = 'filename="%s"' % self.getFileName()
-        self.request.response.setHeader('Content-Disposition', disposition)
-        return data
+        self.task_progress.title = _("Export complete")
+        self.task_progress.force('worksheets', progress=1.0)
+        return wb
 
 
 class FlourishReportSheetsExportSchoolYearView(
@@ -130,8 +166,18 @@
     """A view for exporting report sheets to an XLS file,
        one sheet for each term of the school year."""
 
-    def getFileName(self):
-        return 'report_sheets_%s.xls' % self.schoolyear.__name__
+    @property
+    def base_filename(self):
+        terms = self.getTerms()
+        if not terms:
+            return 'report_sheets'
+        schoolyear = ISchoolYear(terms[-1])
+        return 'report_sheets_%s' % schoolyear.__name__
+
+    def addImporters(self, progress):
+        self.task_progress.add(
+            'worksheets',
+            title=_('School Year Worksheets'), progress=0.0)
 
     def getTerms(self):
         return self.context.values()

=== modified file 'src/schooltool/gradebook/configure.zcml'
--- src/schooltool/gradebook/configure.zcml	2013-02-19 00:18:28 +0000
+++ src/schooltool/gradebook/configure.zcml	2013-08-01 18:41:36 +0000
@@ -372,6 +372,21 @@
       factory=".gradebook_init.GradebookAppStartup"
       name="schooltool.gradebook" />
 
+  <!-- remote tasks -->
+  <class class=".gradebook.GradebookReportTask">
+    <require permission="schooltool.view"
+             interface=".interfaces.IGradebookReportTask" />
+    <require permission="schooltool.edit"
+             set_schema=".interfaces.IGradebookReportTask" />
+  </class>
+
+  <class class=".gradebook.TraversableXLSReportTask">
+    <require permission="schooltool.view"
+             interface="schooltool.report.interfaces.IReportTask" />
+    <require permission="schooltool.edit"
+             set_schema="schooltool.report.interfaces.IReportTask" />
+  </class>
+
   <!-- generations -->
   <utility
       name="schooltool.gradebook"

=== modified file 'src/schooltool/gradebook/gradebook.py'
--- src/schooltool/gradebook/gradebook.py	2013-04-04 17:05:30 +0000
+++ src/schooltool/gradebook/gradebook.py	2013-08-01 18:41:36 +0000
@@ -29,14 +29,18 @@
 from zope.keyreference.interfaces import IKeyReference
 from zope.component import adapts, adapter
 from zope.component import queryMultiAdapter, getMultiAdapter
-from zope.interface import implements, implementer
+from zope.component import getUtility
+from zope.interface import implements, implementer, Interface
 from zope.location.location import LocationProxy
 from zope.publisher.interfaces import IPublishTraverse
 from zope.security.proxy import removeSecurityProxy
+from zope.intid.interfaces import IIntIds
 
 from schooltool import course, requirement
 from schooltool.app.interfaces import ISchoolToolApplication
 from schooltool.basicperson.interfaces import IBasicPerson
+from schooltool.export.export import XLSReportTask
+from schooltool.report.report import ReportTask
 from schooltool.securitypolicy.crowds import ConfigurableCrowd
 from schooltool.securitypolicy.crowds import AdministrationCrowd
 
@@ -569,3 +573,47 @@
         return (AdministrationCrowd(self.context).contains(principal) and
                 super(GradebookEditorsCrowd, self).contains(principal))
 
+
+class GradebookReportTask(ReportTask):
+    implements(interfaces.IGradebookReportTask)
+
+    worksheet_intid = None
+
+    @property
+    def context(self):
+        int_ids = getUtility(IIntIds)
+        worksheet = int_ids.queryObject(self.worksheet_intid)
+        if worksheet is None:
+            return None
+        gradebook = interfaces.IGradebook(worksheet)
+        return gradebook
+
+    @context.setter
+    def context(self, value):
+        unproxied = removeSecurityProxy(value)
+        worksheet = unproxied.__parent__
+        int_ids = getUtility(IIntIds)
+        self.worksheet_intid = int_ids.getId(worksheet)
+
+
+class TraversableXLSReportTask(XLSReportTask):
+    traverse_intid = None
+    traverse_name = None
+
+    @property
+    def context(self):
+        int_ids = getUtility(IIntIds)
+        target = int_ids.queryObject(self.traverse_intid)
+        if target is None:
+            return None
+        request = self.getCurrentRequest()
+        traverser = getMultiAdapter((target, request), Interface, self.traverse_name)
+        result = traverser.traverse(self.traverse_name)
+        return result
+
+    @context.setter
+    def context(self, value):
+        target, name = value
+        int_ids = getUtility(IIntIds)
+        self.traverse_intid = int_ids.getId(target)
+        self.traverse_name = name

=== modified file 'src/schooltool/gradebook/interfaces.py'
--- src/schooltool/gradebook/interfaces.py	2013-04-04 17:05:30 +0000
+++ src/schooltool/gradebook/interfaces.py	2013-08-01 18:41:36 +0000
@@ -28,6 +28,7 @@
 from zope.container.constraints import containers, contains
 from zope.schema.interfaces import IIterableSource
 from schooltool.requirement import interfaces, scoresystem
+from schooltool.report.interfaces import IReportTask
 from schooltool.gradebook import GradebookMessage as _
 
 
@@ -479,3 +480,6 @@
 class ISectionJournalData(Interface):
     """Bridge interface to remove gradebook dependency on lyceum journal."""
 
+
+class IGradebookReportTask(IReportTask):
+    pass

=== modified file 'version.txt.in'
--- version.txt.in	2013-07-01 14:12:05 +0000
+++ version.txt.in	2013-08-01 18:41:36 +0000
@@ -1,1 +1,1 @@
-2.4.2
+2.5.0

